/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
/*******************************************************************************
 *  generated by script                                                        *
 *******************************************************************************/

#ifndef X3DTK_GLSCENEGRAPH_H
#define X3DTK_GLSCENEGRAPH_H

//base
#include "../private/GL_SceneGraphTypes.h"

//componentActors
#include "../private/GL_CoreVisitor.h"
#include "../private/GL_Geometry3DVisitor.h"
#include "../private/GL_GroupingVisitor.h"
#include "../private/GL_RenderingVisitor.h"
#include "../private/GL_ShapeVisitor.h"
#include "../private/GL_TexturingVisitor.h"

//nodes

//Core
#include "../private/GL_Scene.h"
#include "../private/GL_X3DNode.h"

//Geometry3D
#include "../private/BoxDrawArray.h"
#include "../private/ConeDrawArray.h"
#include "../private/CylinderDrawArray.h"
#include "../private/GL_Box.h"
#include "../private/GL_Cone.h"
#include "../private/GL_Cylinder.h"
#include "../private/GL_IndexedFaceSet.h"
#include "../private/GL_Sphere.h"
#include "../private/SphereDrawArray.h"

//Grouping
#include "../private/GL_Group.h"
#include "../private/GL_StaticGroup.h"
#include "../private/GL_Switch.h"
#include "../private/GL_Transform.h"
#include "../private/GL_X3DChildNode.h"
#include "../private/GL_X3DGroupingNode.h"

//Rendering
#include "../private/GL_IndexedLineSet.h"
#include "../private/GL_PointSet.h"
#include "../private/GL_TriangleFanSet.h"
#include "../private/GL_TriangleSet.h"
#include "../private/GL_TriangleStripSet.h"
#include "../private/GL_X3DComposedGeometryNode.h"
#include "../private/GL_X3DGeometryNode.h"

//Shape
#include "../private/GL_Appearance.h"
#include "../private/GL_FillProperties.h"
#include "../private/GL_LineProperties.h"
#include "../private/GL_Material.h"
#include "../private/GL_Shape.h"
#include "../private/GL_X3DAppearanceChildNode.h"
#include "../private/GL_X3DAppearanceNode.h"
#include "../private/GL_X3DMaterialNode.h"
#include "../private/GL_X3DShapeNode.h"

//Texturing
#include "../private/GL_ImageTexture.h"
#include "../private/GL_TextureTransform.h"
#include "../private/GL_X3DTexture2DNode.h"
#include "../private/GL_X3DTextureNode.h"
#include "../private/GL_X3DTextureTransform2DNode.h"
#include "../private/GL_X3DTextureTransformNode.h"

#endif
