/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_CLOG_H
#define X3DTK_CLOG_H

#include <fstream>
#include <iostream>
#include "SFString.h"

#include "Platform.h"

namespace X3DTK {

/*! \brief Stream declared in <b><X3DTK/kernel.h></b> providing a stream to file <em>x3dtk.log</em>
 *
 *  \ingroup type
 */

class X3DOfstream : public std::fstream
{
public:
  /// Constructor. You can specify the path where the log file is written. 
  X3DOfstream(const char *path);
  /// Destructor.
  ~X3DOfstream();
  
  /// Sets the path of the log file.
  void setPath(const char *path);
  /// Removes the log file if empty.
  void removeLog();
    
private:
  void findPath(const char *path);
 
  char *_cwd;  
};

extern X3DOfstream cx3d;

}

#endif
