/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_MESH_EDGESDRAWERCOREVISITOR_H
#define X3DTK_MESH_EDGESDRAWERCOREVISITOR_H

#include "MESH_EdgesDrawerStateVariables.h"
#include "MESH_CoreVisitor.h"
#include "MESH_Vertex.h"
#include "MESH_Transform.h"

namespace X3DTK {
namespace MESH {

/*! \brief Class declared in <b><X3DTK/MESH/edgesdrawer.h></b> providing a visitor of the 
 *  Core component of the MESH::TemplateEdgesDrawer processor.
 *
 *  \ingroup MESH
 */

template<class MData, class VData, class EData, class FData, bool RW>
class TemplateEdgesDrawerCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  TemplateEdgesDrawerCoreVisitor();
  /// Enters a Mesh.
  static void enterVertex(TemplateVertex<MData, VData, EData, FData, RW> *V);

  /// Enters a Transform : push matrix
  static void enterTransform(Transform *T);
  /// Leaves a Transform : pop matrix
  static void leaveTransform(Transform *T);
};

}
}

#include "MESH_EdgesDrawerCoreVisitor.inl"

#endif
