/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_QFILEELEMENT_H
#define X3DTK_QFILEELEMENT_H

#include "X3DFileElement.h"

namespace X3DTK {

class QFileElementImplementation;

namespace X3D {

class QSAX2X3DHandler;

}

/*! \brief Class declared in <b><X3DTK/kernel.h></b> providing an implementation
 *  of X3DFileElement for the Qt library.
 *
 *  \ingroup X3DLoader
 */
 
class QFileElement : public X3DFileElement
{
  friend class X3D::QSAX2X3DHandler;
public:
  /// Gets the name.
  SFString getName() const;
  /// Gets the attribute at the index i.
  SFString getAttribute(int i) const;
  /// Gets the index of the attribute. Returns -1 if doesn't exist.
  int getIndexAttribute(const SFString &attribute) const;
  
private:
  QFileElementImplementation *impl;
  QFileElement(const SFString &name, const void *const attributes);
  ~QFileElement();  
};

}

#endif
