/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_X3D_MESHBUILDERCOREVISITOR_H
#define X3DTK_X3D_MESHBUILDERCOREVISITOR_H

#include "X3D_CoreVisitor.h"
#include "X3D_MeshBuilderStateVariables.h"
#include "X3D_Scene.h"
#include "MESH_Scene.h"

namespace X3DTK {
namespace X3D {

class Scene;
class X3DNode;

/*! \brief Class declared in <b><X3DTK/X3D/meshbuilder.h></b> providing a visitor
 *  of the Core component for the X3D::TemplateMeshBuilder processor.
 *
 *  \ingroup X3D
 */

template<class MData, class VData, class EData, class FData, bool RW>
class TemplateMeshBuilderCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  TemplateMeshBuilderCoreVisitor();
    
  /// Enters a Scene.
  static void enterScene(Scene *S);
  /// Enters an X3DNode.
  static void enterX3DNode(X3DNode *N);

  /// Walks on an X3DNode.
  static bool walkOnX3DNode(X3DNode *N, SFNode child);
  
  /// Enters a Scene.
  static void leaveX3DNode(X3DNode *N);
};

}
}

#include "X3D_MeshBuilderCoreVisitor.inl"

#endif
