/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_X3D_SCENESAVERWRITECOREVISITOR_H
#define X3DTK_X3D_SCENESAVERWRITECOREVISITOR_H

#include "X3D_CoreVisitor.h"
#include "X3D_SceneSaverStateVariables.h"

namespace X3DTK {
namespace X3D {

class X3DNode;
class Scene;

/*! \brief Class declared in <b><X3DTK/X3D/scenesaver.h></b> providing a visitor
 *  of the Core component for the Write traversal of the X3D::SceneSaver processor.
 *
 *  \ingroup X3D
 */
 
class SceneSaverWriteCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  SceneSaverWriteCoreVisitor();

  /// Enters a X3DNode.
  static void enterX3DNode(X3DNode *N);
  /// Walks on a X3DNode.
  static bool walkOnX3DNode(X3DNode *N, SFNode Child);
  /// Enters a X3DNode.
  static void leaveX3DNode(X3DNode *N);
  /// Leaves a Scene.
  static void leaveScene(Scene *S);

};

}
}

#endif
